Index: trunk/source/geometry/navigation/src/G4PropagatorInField.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4PropagatorInField.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4PropagatorInField.cc	(revision 1347)
@@ -36,5 +36,5 @@
 // 17.03.97 John Apostolakis,   renaming new set functions being added
 //
-// $Id: G4PropagatorInField.cc,v 1.51 2010/03/08 13:57:34 gcosmo Exp $
+// $Id: G4PropagatorInField.cc,v 1.52 2010/07/13 15:59:42 gcosmo Exp $
 // GEANT4 tag $ Name:  $
 // ---------------------------------------------------------------------------
@@ -470,5 +470,5 @@
                                         G4VPhysicalVolume*   startVolume)
 {
-  const G4int verboseLevel= fVerboseLevel;
+  const G4int verboseLevel=fVerboseLevel;
   const G4ThreeVector StartPosition       = StartFT.GetPosition();
   const G4ThreeVector StartUnitVelocity   = StartFT.GetMomentumDir();
@@ -477,11 +477,10 @@
 
   G4double step_len = CurrentFT.GetCurveLength() - StartFT.GetCurveLength();
+
+  G4int oldprec;   // cout/cerr precision settings
       
-  if( ((stepNo == 0) && (verboseLevel <3))
-      || (verboseLevel >= 3) )
-  {
-    static G4int noPrecision= 4;
-    G4cout.precision(noPrecision);
-    // G4cout.setf(ios_base::fixed,ios_base::floatfield);
+  if( ((stepNo == 0) && (verboseLevel <3)) || (verboseLevel >= 3) )
+  {
+    oldprec = G4cout.precision(4);
     G4cout << std::setw( 6)  << " " 
            << std::setw( 25) << " Current Position  and  Direction" << " "
@@ -495,77 +494,60 @@
            << std::setw( 7) << " N_y " << " "
            << std::setw( 7) << " N_z " << " " ;
-    //            << G4endl; 
-    G4cout     // << " >>> "
-           << std::setw( 7) << " Delta|N|" << " "
-      //   << std::setw( 7) << " Delta(N_z) " << " "
+    G4cout << std::setw( 7) << " Delta|N|" << " "
            << std::setw( 9) << "StepLen" << " "  
            << std::setw(12) << "StartSafety" << " "  
            << std::setw( 9) << "PhsStep" << " ";  
-    if( startVolume ) {
-      G4cout << std::setw(18) << "NextVolume" << " "; 
-    }
+    if( startVolume )
+      { G4cout << std::setw(18) << "NextVolume" << " "; }
+    G4cout.precision(oldprec);
     G4cout << G4endl;
   }
-  if((stepNo == 0) && (verboseLevel <=3)){
-     // Recurse to print the start values
-     //
-     printStatus( StartFT, StartFT, -1.0, safety, -1, startVolume);
-   }
-   if( verboseLevel <= 3 )
-   {
-     if( stepNo >= 0)
-       G4cout << std::setw( 4) << stepNo << " ";
-     else
-       G4cout << std::setw( 5) << "Start" ;
-     G4cout.precision(8);
-     G4cout << std::setw(10) << CurrentFT.GetCurveLength() << " "; 
-     G4cout.precision(8);
-     G4cout << std::setw(10) << CurrentPosition.x() << " "
-            << std::setw(10) << CurrentPosition.y() << " "
-            << std::setw(10) << CurrentPosition.z() << " ";
-     G4cout.precision(4);
-     G4cout << std::setw( 7) << CurrentUnitVelocity.x() << " "
-            << std::setw( 7) << CurrentUnitVelocity.y() << " "
-            << std::setw( 7) << CurrentUnitVelocity.z() << " ";
-     //  G4cout << G4endl; 
-     //     G4cout << " >>> " ; 
-     G4cout.precision(3); 
-     G4cout << std::setw( 7) << CurrentFT.GetMomentum().mag()- StartFT.GetMomentum().mag() << " "; 
-     //   << std::setw( 7) << CurrentUnitVelocity.z() - InitialUnitVelocity.z() << " ";
-     G4cout << std::setw( 9) << step_len << " "; 
-     G4cout << std::setw(12) << safety << " ";
-     if( requestStep != -1.0 ) 
-       G4cout << std::setw( 9) << requestStep << " ";
-     else
-       G4cout << std::setw( 9) << "Init/NotKnown" << " "; 
-
-     if( startVolume != 0)
-     {
-       G4cout << std::setw(12) << startVolume->GetName() << " ";
-     }
-#if 0
-     else
-     {
-       if( step_len != -1 )
-         G4cout << std::setw(12) << "OutOfWorld" << " ";
-       else
-         G4cout << std::setw(12) << "NotGiven" << " ";
-     }
-#endif
-
-     G4cout << G4endl;
-   }
-   else // if( verboseLevel > 3 )
-   {
-     //  Multi-line output
-       
-     G4cout << "Step taken was " << step_len  
-            << " out of PhysicalStep = " <<  requestStep << G4endl;
-     G4cout << "Final safety is: " << safety << G4endl;
-
-     G4cout << "Chord length = " << (CurrentPosition-StartPosition).mag()
-            << G4endl;
-     G4cout << G4endl; 
-   }
+  if((stepNo == 0) && (verboseLevel <=3))
+  {
+    // Recurse to print the start values
+    //
+    printStatus( StartFT, StartFT, -1.0, safety, -1, startVolume);
+  }
+  if( verboseLevel <= 3 )
+  {
+    if( stepNo >= 0)
+      { G4cout << std::setw( 4) << stepNo << " "; }
+    else
+      { G4cout << std::setw( 5) << "Start" ; }
+    oldprec = G4cout.precision(8);
+    G4cout << std::setw(10) << CurrentFT.GetCurveLength() << " "; 
+    G4cout.precision(8);
+    G4cout << std::setw(10) << CurrentPosition.x() << " "
+           << std::setw(10) << CurrentPosition.y() << " "
+           << std::setw(10) << CurrentPosition.z() << " ";
+    G4cout.precision(4);
+    G4cout << std::setw( 7) << CurrentUnitVelocity.x() << " "
+           << std::setw( 7) << CurrentUnitVelocity.y() << " "
+           << std::setw( 7) << CurrentUnitVelocity.z() << " ";
+    G4cout.precision(3); 
+    G4cout << std::setw( 7)
+           << CurrentFT.GetMomentum().mag()-StartFT.GetMomentum().mag() << " "; 
+    G4cout << std::setw( 9) << step_len << " "; 
+    G4cout << std::setw(12) << safety << " ";
+    if( requestStep != -1.0 ) 
+      { G4cout << std::setw( 9) << requestStep << " "; }
+    else
+      { G4cout << std::setw( 9) << "Init/NotKnown" << " "; }
+    if( startVolume != 0)
+      { G4cout << std::setw(12) << startVolume->GetName() << " "; }
+    G4cout.precision(oldprec);
+    G4cout << G4endl;
+  }
+  else // if( verboseLevel > 3 )
+  {
+    //  Multi-line output
+      
+    G4cout << "Step taken was " << step_len  
+           << " out of PhysicalStep = " <<  requestStep << G4endl;
+    G4cout << "Final safety is: " << safety << G4endl;
+    G4cout << "Chord length = " << (CurrentPosition-StartPosition).mag()
+           << G4endl;
+    G4cout << G4endl; 
+  }
 }
 
Index: trunk/source/geometry/navigation/src/G4RegularNavigation.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4RegularNavigation.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4RegularNavigation.cc	(revision 1347)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4RegularNavigation.cc,v 1.9 2009/01/27 09:31:29 gcosmo Exp $
+// $Id: G4RegularNavigation.cc,v 1.15 2010/11/19 15:13:39 gcosmo Exp $
 // GEANT4 tag $ Name:$
 //
@@ -45,5 +45,5 @@
 //------------------------------------------------------------------
 G4RegularNavigation::G4RegularNavigation()
-  : fVerbose(1), fCheck(true)
+  : fverbose(false), fcheck(false), fnormalNav(0)
 {
   kCarTolerance = G4GeometryTolerance::GetInstance()->GetSurfaceTolerance();
@@ -122,5 +122,5 @@
 //------------------------------------------------------------------
 G4double G4RegularNavigation::ComputeStepSkippingEqualMaterials(
-                                G4ThreeVector localPoint,
+                                      G4ThreeVector& localPoint,
                                 const G4ThreeVector& localDirection,
                                 const G4double currentProposedStepLength,
@@ -291,12 +291,10 @@
                                   const G4ThreeVector& globalPoint,
                                   const G4ThreeVector* globalDirection,
-                                  const G4bool pLocatedOnEdge, 
+                                  const G4bool, // pLocatedOnEdge, 
                                   G4ThreeVector& localPoint )
 {
-  G4SmartVoxelHeader *motherVoxelHeader;
   G4VPhysicalVolume *motherPhysical, *pPhysical;
   G4PhantomParameterisation *pParam;
   G4LogicalVolume *motherLogical;
-  G4VSolid *pSolid;
   G4ThreeVector localDir;
   G4int replicaNo;
@@ -304,11 +302,8 @@
   motherPhysical = history.GetTopVolume();
   motherLogical = motherPhysical->GetLogicalVolume();
-  motherVoxelHeader = motherLogical->GetVoxelHeader();
   
   pPhysical = motherLogical->GetDaughter(0);
   pParam = (G4PhantomParameterisation*)(pPhysical->GetParameterisation());
   
-  pSolid = pParam->GetContainerSolid();
-  
   // Save parent history in touchable history
   // ... for use as parent t-h in ComputeMaterial method of param
@@ -327,41 +322,27 @@
   }
 
-  // Check that track is not on the surface and check that track is not
-  // exiting the voxel parent volume
-  //
-  if ( !G4AuxiliaryNavServices::CheckPointOnSurface(pSolid, localPoint,
-          globalDirection, history.GetTopTransform(), pLocatedOnEdge) 
-     || G4AuxiliaryNavServices::CheckPointExiting(pSolid, localPoint,
-          globalDirection, history.GetTopTransform() ) )
-  {
-  }
-  else
-  {
-    // Enter this daughter
-    //
-    replicaNo = pParam->GetReplicaNo( localPoint, localDir );
-
-    if( replicaNo < 0 || replicaNo >= G4int(pParam->GetNoVoxel()) )
-    {
-      return false;
-    }
-
-    // Set the correct copy number in physical
-    //
-    pPhysical->SetCopyNo(replicaNo);
-    pParam->ComputeTransformation(replicaNo,pPhysical);
-
-    history.NewLevel(pPhysical, kParameterised, replicaNo );
-    localPoint = history.GetTopTransform().TransformPoint(globalPoint);
-
-    // Set the correct solid and material in Logical Volume
-    //
-    G4LogicalVolume *pLogical = pPhysical->GetLogicalVolume();
+  // Enter this daughter
+  //
+  replicaNo = pParam->GetReplicaNo( localPoint, localDir );
+
+  if( replicaNo < 0 || replicaNo >= G4int(pParam->GetNoVoxel()) )
+  {
+    return false;
+  }
+
+  // Set the correct copy number in physical
+  //
+  pPhysical->SetCopyNo(replicaNo);
+  pParam->ComputeTransformation(replicaNo,pPhysical);
+
+  history.NewLevel(pPhysical, kParameterised, replicaNo );
+  localPoint = history.GetTopTransform().TransformPoint(globalPoint);
+
+  // Set the correct solid and material in Logical Volume
+  //
+  G4LogicalVolume *pLogical = pPhysical->GetLogicalVolume();
       
-    pLogical->UpdateMaterial(pParam->ComputeMaterial(replicaNo,
-                             pPhysical, &parentTouchable) );
-    return true;
-  }
-
-  return false;
-}
+  pLogical->UpdateMaterial(pParam->ComputeMaterial(replicaNo,
+                           pPhysical, &parentTouchable) );
+  return true;
+}
Index: trunk/source/geometry/navigation/src/G4ReplicaNavigation.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4ReplicaNavigation.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4ReplicaNavigation.cc	(revision 1347)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ReplicaNavigation.cc,v 1.19 2008/04/28 15:39:55 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4ReplicaNavigation.cc,v 1.20 2010/07/13 15:59:42 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 //
@@ -1039,4 +1039,5 @@
     G4Exception("G4ReplicaNavigation::BackLocate()", "InvalidSetup",
                 FatalException, "The World volume must be a Placement!");
+    return kInside;
   }
 
Index: trunk/source/geometry/navigation/src/G4SimpleLocator.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4SimpleLocator.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4SimpleLocator.cc	(revision 1347)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4SimpleLocator.cc,v 1.5 2008/12/11 10:27:58 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4SimpleLocator.cc,v 1.6 2010/07/13 15:59:42 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Class G4SimpleLocator implementation
@@ -105,4 +105,6 @@
 
   G4int substep_no = 0;
+
+  G4int oldprc;  // cout/cerr precision settings
 
   // Limits for substep number
@@ -358,5 +360,5 @@
                   << GetEpsilonStepFor() << G4endl;
          }
-         G4cerr.precision(20);
+         oldprc = G4cerr.precision(20);
          G4cerr << " Point A (Curve start)   is " << CurveStartPointVelocity
                 << G4endl;
@@ -373,4 +375,5 @@
          G4cerr << "        LocateIntersection parameters are : Substep no= "
                 << substep_no << G4endl;
+         G4cerr.precision(oldprc);
 
          G4Exception("G4SimpleLocator::EstimateIntersectionPoint()",
@@ -452,5 +455,5 @@
                  -1.0, NewSafety, substep_no);
     G4cout << G4endl;
-    G4cout.precision( 10 ); 
+    oldprc = G4cout.precision(10); 
     G4double done_len = CurrentA_PointVelocity.GetCurveLength(); 
     G4double full_len = CurveEndPointVelocity.GetCurveLength();
@@ -460,4 +463,5 @@
            << " out of " << full_len << " required." << G4endl;
     G4cout << "        Remaining length = " << full_len - done_len << G4endl; 
+    G4cout.precision(oldprc); 
 
     G4Exception("G4SimpleLocator::EstimateIntersectionPoint()",
@@ -467,5 +471,5 @@
   else if( substep_no >= warn_substeps )
   {  
-    G4int oldprc= G4cout.precision( 10 ); 
+    oldprc= G4cout.precision(10); 
     G4cout << "WARNING - G4SimpleLocator::EstimateIntersectionPoint()"
            << G4endl
@@ -475,8 +479,8 @@
            << "          Warning level = " << warn_substeps
            << " and maximum substeps = " << max_substeps << G4endl;
+    G4cout.precision(oldprc); 
     G4Exception("G4SimpleLocator::EstimateIntersectionPoint()",
                 "DifficultyToLocateIntersection", JustWarning,
                 "Many substeps while trying to locate intersection.");
-    G4cout.precision( oldprc ); 
   }
   return  !there_is_no_intersection; //  Success or failure
Index: trunk/source/geometry/navigation/src/G4TransportationManager.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4TransportationManager.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4TransportationManager.cc	(revision 1347)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4TransportationManager.cc,v 1.15 2007/04/12 11:51:48 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4TransportationManager.cc,v 1.16 2010/07/13 15:59:42 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 //
@@ -56,21 +56,5 @@
 G4TransportationManager::G4TransportationManager() 
 { 
-  if (!fTransportationManager)
-  {
-    // Create the navigator for tracking and activate it; add to collections
-    //
-    G4Navigator* trackingNavigator = new G4Navigator();
-    trackingNavigator->Activate(true);
-    fNavigators.push_back(trackingNavigator);
-    fActiveNavigators.push_back(trackingNavigator);
-    fWorlds.push_back(trackingNavigator->GetWorldVolume()); // NULL registered
-
-    fGeomMessenger     = new G4GeometryMessenger(this);
-    fFieldManager      = new G4FieldManager();
-    fPropagatorInField = new G4PropagatorInField(trackingNavigator,
-                                                 fFieldManager);
-    fSafetyHelper      = new G4SafetyHelper();
-  }
-  else
+  if (fTransportationManager)
   {
     G4cerr << "Only ONE instance of G4TransportationManager is allowed!"
@@ -80,4 +64,17 @@
                 "Only ONE instance of G4TransportationManager is allowed!");
   }
+
+  // Create the navigator for tracking and activate it; add to collections
+  //
+  G4Navigator* trackingNavigator = new G4Navigator();
+  trackingNavigator->Activate(true);
+  fNavigators.push_back(trackingNavigator);
+  fActiveNavigators.push_back(trackingNavigator);
+  fWorlds.push_back(trackingNavigator->GetWorldVolume()); // NULL registered
+
+  fGeomMessenger    = new G4GeometryMessenger(this);
+  fFieldManager     = new G4FieldManager();
+  fPropagatorInField= new G4PropagatorInField(trackingNavigator,fFieldManager);
+  fSafetyHelper     = new G4SafetyHelper();
 } 
 
@@ -329,5 +326,9 @@
    std::vector<G4Navigator*>::iterator pNav =
      std::find(fNavigators.begin(), fNavigators.end(), aNavigator);
-   if (pNav == fNavigators.end())
+   if (pNav != fNavigators.end())
+   {
+      (*pNav)->Activate(false);
+   }
+   else
    {
       G4String message
@@ -337,8 +338,5 @@
                   "NoEffect", JustWarning, message);
    }
-   else
-   {
-      (*pNav)->Activate(false);
-   }
+
    std::vector<G4Navigator*>::iterator pActiveNav =
      std::find(fActiveNavigators.begin(), fActiveNavigators.end(), aNavigator);
Index: trunk/source/geometry/navigation/src/G4VIntersectionLocator.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4VIntersectionLocator.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4VIntersectionLocator.cc	(revision 1347)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4VIntersectionLocator.cc,v 1.7 2009/11/27 15:21:59 japost Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4VIntersectionLocator.cc,v 1.8 2010/07/13 15:59:42 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Class G4VIntersectionLocator implementation
@@ -83,10 +83,9 @@
 
   G4double step_len = CurrentFT.GetCurveLength() - StartFT.GetCurveLength();
-      
+  G4int oldprc;  // cout/cerr precision settings
+
   if( ((stepNo == 0) && (verboseLevel <3)) || (verboseLevel >= 3) )
   {
-    static G4int noPrecision= 4;
-    G4cout.precision(noPrecision);
-    // G4cout.setf(ios_base::fixed,ios_base::floatfield);
+    oldprc = G4cout.precision(4);
     G4cout << std::setw( 6)  << " " 
            << std::setw( 25) << " Current Position  and  Direction" << " "
@@ -100,13 +99,10 @@
            << std::setw( 7) << " N_y " << " "
            << std::setw( 7) << " N_z " << " " ;
-    //            << G4endl; 
-    G4cout     // << " >>> "
-           << std::setw( 7) << " Delta|N|" << " "
-      //   << std::setw( 7) << " Delta(N_z) " << " "
+    G4cout << std::setw( 7) << " Delta|N|" << " "
            << std::setw( 9) << "StepLen" << " "  
            << std::setw(12) << "StartSafety" << " "  
            << std::setw( 9) << "PhsStep" << " ";  
-  
     G4cout << G4endl;
+    G4cout.precision(oldprc);
   }
   if((stepNo == 0) && (verboseLevel <=3))
@@ -126,7 +122,6 @@
        G4cout << std::setw( 5) << "Start" ;
     }
-    G4cout.precision(8);
+    oldprc = G4cout.precision(8);
     G4cout << std::setw(10) << CurrentFT.GetCurveLength() << " "; 
-    G4cout.precision(8);
     G4cout << std::setw(10) << CurrentPosition.x() << " "
            << std::setw(10) << CurrentPosition.y() << " "
@@ -136,36 +131,32 @@
            << std::setw( 7) << CurrentUnitVelocity.y() << " "
            << std::setw( 7) << CurrentUnitVelocity.z() << " ";
-     //  G4cout << G4endl; 
-     //     G4cout << " >>> " ; 
-     G4cout.precision(3); 
-     G4cout << std::setw( 7)
-            << CurrentFT.GetMomentum().mag()- StartFT.GetMomentum().mag()
-            << " "; 
-     //   << std::setw( 7)
-     //   << CurrentUnitVelocity.z() - InitialUnitVelocity.z() << " ";
-     G4cout << std::setw( 9) << step_len << " "; 
-     G4cout << std::setw(12) << safety << " ";
-     if( requestStep != -1.0 )
-     {
-       G4cout << std::setw( 9) << requestStep << " ";
-     }
-     else
-     {
-       G4cout << std::setw( 9) << "Init/NotKnown" << " "; 
-     }
-     G4cout << G4endl;
-   }
-   else // if( verboseLevel > 3 )
-   {
-     //  Multi-line output
+    G4cout.precision(3); 
+    G4cout << std::setw( 7)
+           << CurrentFT.GetMomentum().mag()- StartFT.GetMomentum().mag()
+           << " "; 
+    G4cout << std::setw( 9) << step_len << " "; 
+    G4cout << std::setw(12) << safety << " ";
+    if( requestStep != -1.0 )
+    {
+      G4cout << std::setw( 9) << requestStep << " ";
+    }
+    else
+    {
+      G4cout << std::setw( 9) << "Init/NotKnown" << " "; 
+    }
+    G4cout << G4endl;
+    G4cout.precision(oldprc);
+  }
+  else // if( verboseLevel > 3 )
+  {
+    //  Multi-line output
        
-     G4cout << "Step taken was " << step_len  
-            << " out of PhysicalStep= " <<  requestStep << G4endl;
-     G4cout << "Final safety is: " << safety << G4endl;
-
-     G4cout << "Chord length = " << (CurrentPosition-StartPosition).mag()
-            << G4endl;
-     G4cout << G4endl; 
-   }
+    G4cout << "Step taken was " << step_len  
+           << " out of PhysicalStep= " <<  requestStep << G4endl;
+    G4cout << "Final safety is: " << safety << G4endl;
+    G4cout << "Chord length = " << (CurrentPosition-StartPosition).mag()
+           << G4endl;
+    G4cout << G4endl; 
+  }
 }
 
